import type { Action, Reducer } from './types';
declare type MergeIntersections<T> = T extends infer O ? {
    [K in keyof O]: O[K];
} : never;
export declare function combine<A>(a: A): MergeIntersections<A>;
export declare function combine<A, B>(a: A, b: B): MergeIntersections<A & B>;
export declare function combine<A, B, C>(a: A, b: B, c: C): MergeIntersections<A & B & C>;
export declare function combine<A, B, C, D>(a: A, b: B, c: C, d: D): MergeIntersections<A & B & C & D>;
export declare function combine<A, B, C, D, E>(a: A, b: B, c: C, d: D, e: E): MergeIntersections<A & B & C & D & E>;
interface TSlice<A = any, SS = any> {
    actions: {
        [K in keyof A]: A[K];
    };
    reducer: Reducer<SS, Action>;
    name: string;
}
export declare function createActionMap<A>(a: TSlice<A>): MergeIntersections<A>;
export declare function createActionMap<A, B>(a: TSlice<A>, b: TSlice<B>): MergeIntersections<A & B>;
export declare function createActionMap<A, B, C>(a: TSlice<A>, b: TSlice<B>, c: TSlice<C>): MergeIntersections<A & B & C>;
export declare function createActionMap<A, B, C, D>(a: TSlice<A>, b: TSlice<B>, c: TSlice<C>, d: TSlice<D>): MergeIntersections<A & B & C & D>;
export declare function createActionMap<A, B, C, D, E>(a: TSlice<A>, b: TSlice<B>, c: TSlice<C>, d: TSlice<D>, e: TSlice<E>): MergeIntersections<A & B & C & D & E>;
export declare function createReducerMap<KV extends Array<{
    name: P;
    reducer: Reducer;
}>, P extends keyof any>(...args: KV): {
    [K in KV[number]['name']]: Extract<KV[number], {
        name: K;
    }>['reducer'];
};
export {};
