"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createReducerMap = exports.createActionMap = exports.combine = void 0;
function combine() {
    var e_1, _a;
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var newObj = {};
    try {
        for (var args_1 = __values(args), args_1_1 = args_1.next(); !args_1_1.done; args_1_1 = args_1.next()) {
            var obj = args_1_1.value;
            for (var key in obj) {
                if (newObj.hasOwnProperty(key)) {
                    console.warn("collision detected: ".concat(key, " already exists"), args);
                }
                newObj[key] = obj[key];
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (args_1_1 && !args_1_1.done && (_a = args_1.return)) _a.call(args_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return newObj;
}
exports.combine = combine;
function createActionMap() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return args.reduce(function (acc, slice) {
        return combine(acc, slice.actions);
    }, {});
}
exports.createActionMap = createActionMap;
function createReducerMap() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return args.reduce(function (acc, slice) {
        if (acc.hasOwnProperty(slice.name)) {
            console.warn("Reducer collision detected: ".concat(slice.name, " already exists"));
        }
        acc[slice.name] = slice.reducer;
        return acc;
    }, {});
}
exports.createReducerMap = createReducerMap;
//# sourceMappingURL=combine.js.map