"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.assignReducers = void 0;
var create_slice_1 = __importDefault(require("./create-slice"));
function assignReducers(initialState) {
    return {
        set: function (_, p) { return p; },
        reset: function () { return initialState; },
    };
}
exports.assignReducers = assignReducers;
function createAssign(_a) {
    var name = _a.name, initialState = _a.initialState, extraReducers = _a.extraReducers;
    return (0, create_slice_1.default)({
        name: name,
        useImmer: false,
        initialState: initialState,
        reducers: assignReducers(initialState),
        extraReducers: extraReducers,
    });
}
exports.default = createAssign;
//# sourceMappingURL=create-assign.js.map