"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var create_list_1 = require("./create-list");
var create_map_1 = require("./create-map");
var create_slice_1 = __importDefault(require("./create-slice"));
function createListTable(_a) {
    var name = _a.name, _b = _a.initialState, initialState = _b === void 0 ? {} : _b, extraReducers = _a.extraReducers;
    var listReducer = (0, create_list_1.listReducers)([]);
    var map = (0, create_map_1.mapReducers)(initialState);
    return (0, create_slice_1.default)({
        name: name,
        initialState: initialState,
        extraReducers: extraReducers,
        useImmer: false,
        reducers: {
            add: map.add,
            set: map.set,
            remove: map.remove,
            reset: map.reset,
            addItems: function (state, p) {
                var nextState = __assign({}, state);
                Object.keys(p).forEach(function (key) {
                    if (nextState[key]) {
                        nextState[key] = listReducer.add(nextState[key], p[key]);
                    }
                    else {
                        nextState[key] = p[key];
                    }
                });
                return nextState;
            },
        },
    });
}
exports.default = createListTable;
//# sourceMappingURL=create-list-table.js.map