import type { Action, SliceHelper, Reducer } from './types';
export declare type LoadingStatus = 'loading' | 'success' | 'error' | 'idle';
export interface LoadingItemState<M extends Record<string, any> = Record<string, any>> {
    status: LoadingStatus;
    message: string;
    lastRun: number;
    lastSuccess: number;
    meta: M;
}
export declare type LoadingPayload<M extends Record<string, any> = Record<string, any>> = Partial<{
    message: string;
    timestamp: number;
    meta: M;
}>;
interface LoadingActions<M extends Record<string, any> = Record<string, any>> {
    loading: LoadingPayload<M>;
    success: LoadingPayload<M>;
    error: LoadingPayload<M>;
    reset: never;
}
export declare function defaultLoadingItem<M extends Record<string, any> = Record<string, any>>(li?: Partial<LoadingItemState<M>>): LoadingItemState<M>;
export declare function loadingReducers<M extends Record<string, any> = Record<string, any>>(initialState: LoadingItemState<M>): {
    success: (state: LoadingItemState<M> | undefined, payload?: LoadingPayload<M>) => LoadingItemState<M>;
    error: (state: LoadingItemState<M> | undefined, payload?: LoadingPayload<M>) => LoadingItemState<M>;
    loading: (state: LoadingItemState<M> | undefined, payload?: LoadingPayload<M>) => LoadingItemState<M>;
    reset: () => LoadingItemState<M>;
};
export default function createLoader<M extends Record<string, any> = Record<string, any>>({ name, initialState, extraReducers, }: SliceHelper<LoadingItemState<M>>): {
    name: string;
    reducer: Reducer<LoadingItemState<M>, Action>;
    actions: {
        [key in keyof LoadingActions]: LoadingActions[key] extends never ? () => Action : (payload?: LoadingActions<M>[key]) => Action<LoadingActions<M>[key]>;
    };
    toString: () => string;
};
export default function createLoader<M extends Record<string, any> = Record<string, any>>({ name, initialState, extraReducers, }: SliceHelper<LoadingItemState<M>>): {
    name: string;
    reducer: Reducer<LoadingItemState<M>, Action>;
    actions: {
        [key in keyof LoadingActions]: LoadingActions[key] extends never ? () => Action : (payload?: LoadingActions[key]) => Action<LoadingActions[key]>;
    };
    toString: () => string;
};
export {};
