"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadingReducers = exports.defaultLoadingItem = void 0;
var create_slice_1 = __importDefault(require("./create-slice"));
var ts = function () { return Date.now(); };
function defaultLoadingItem(li) {
    if (li === void 0) { li = {}; }
    return __assign({ status: 'idle', message: '', lastRun: 0, lastSuccess: 0, meta: {} }, li);
}
exports.defaultLoadingItem = defaultLoadingItem;
function loadingReducers(initialState) {
    return {
        success: function (state, payload) {
            if (payload === void 0) { payload = {}; }
            return ({
                status: 'success',
                message: payload.message || initialState.message,
                meta: payload.meta || {},
                lastRun: state && state.lastRun ? state.lastRun : initialState.lastRun,
                lastSuccess: payload.timestamp || ts(),
            });
        },
        error: function (state, payload) {
            if (payload === void 0) { payload = {}; }
            return ({
                status: 'error',
                message: payload.message || initialState.message,
                meta: payload.meta || {},
                lastRun: state && state.lastRun ? state.lastRun : initialState.lastRun,
                lastSuccess: state && state.lastSuccess
                    ? state.lastSuccess
                    : initialState.lastSuccess,
            });
        },
        loading: function (state, payload) {
            if (payload === void 0) { payload = {}; }
            return ({
                status: 'loading',
                message: payload.message || initialState.message,
                meta: payload.meta || {},
                lastRun: payload.timestamp || ts(),
                lastSuccess: state && state.lastSuccess
                    ? state.lastSuccess
                    : initialState.lastSuccess,
            });
        },
        reset: function () { return initialState; },
    };
}
exports.loadingReducers = loadingReducers;
function createLoader(_a) {
    var name = _a.name, _b = _a.initialState, initialState = _b === void 0 ? defaultLoadingItem() : _b, extraReducers = _a.extraReducers;
    return (0, create_slice_1.default)({
        name: name,
        initialState: initialState,
        extraReducers: extraReducers,
        useImmer: false,
        reducers: loadingReducers(initialState),
    });
}
exports.default = createLoader;
//# sourceMappingURL=create-loader.js.map