import type { AnyState, PatchEntity, SliceHelper } from './types';
export interface MapReducers<State extends AnyState = AnyState> {
    add: (state: State, payload: State) => State;
    set: (state: State, payload: State) => State;
    remove: (state: State, payload: string[]) => State;
    reset: (state: State) => State;
    merge: (state: State, payload: PatchEntity<State>) => State;
    patch: (state: State, payload: PatchEntity<State>) => State;
}
export declare function mapReducers<State extends AnyState>(initialState?: State): MapReducers<State>;
export default function createMap<State extends AnyState>({ name, extraReducers, initialState, }: SliceHelper<State>): {
    name: string;
    reducer: import("./types").Reducer<State, import("./types").Action<any, string>>;
    actions: {
        add: Object extends State ? (payload?: any) => import("./types").Action<any, string> : State extends never ? () => import("./types").Action<any, string> : (payload: State) => import("./types").Action<State, string>;
        set: Object extends State ? (payload?: any) => import("./types").Action<any, string> : State extends never ? () => import("./types").Action<any, string> : (payload: State) => import("./types").Action<State, string>;
        remove: (payload: string[]) => import("./types").Action<string[], string>;
        patch: Object extends PatchEntity<State> ? (payload?: any) => import("./types").Action<any, string> : (payload: PatchEntity<State>) => import("./types").Action<PatchEntity<State>, string>;
        reset: () => import("./types").Action<any, string>;
    };
    toString: () => string;
};
