"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapReducers = void 0;
var create_slice_1 = __importDefault(require("./create-slice"));
function mapReducers(initialState) {
    if (initialState === void 0) { initialState = {}; }
    return {
        add: function (state, payload) {
            var newState = __assign({}, state);
            Object.keys(payload).forEach(function (key) {
                newState[key] = payload[key];
            });
            return newState;
        },
        set: function (_, payload) { return payload; },
        remove: function (state, payload) {
            var newState = __assign({}, state);
            payload.forEach(function (key) {
                delete newState[key];
            });
            return newState;
        },
        reset: function (_) { return initialState; },
        patch: function (state, payload) {
            var newState = __assign({}, state);
            Object.keys(payload).forEach(function (id) {
                if (typeof payload[id] !== 'object') {
                    return;
                }
                var entity = payload[id];
                if (entity) {
                    var s_1 = newState;
                    var nextEntity_1 = __assign({}, s_1[id]);
                    Object.keys(entity).forEach(function (key) {
                        if (s_1.hasOwnProperty(id)) {
                            nextEntity_1[key] = payload[id][key];
                        }
                    });
                    newState[id] = nextEntity_1;
                }
            });
            return newState;
        },
        merge: function (state, payload) {
            var newState = __assign({}, state);
            Object.keys(payload).forEach(function (id) {
                if (typeof payload[id] !== 'object') {
                    return;
                }
                var entity = payload[id];
                if (entity) {
                    var s = newState;
                    if (!s.hasOwnProperty(id)) {
                        return;
                    }
                    var nextEntity_2 = __assign({}, s[id]);
                    Object.keys(entity).forEach(function (key) {
                        var prop = payload[id][key];
                        if (Array.isArray(nextEntity_2[key])) {
                            nextEntity_2[key] = __spreadArray(__spreadArray([], __read(nextEntity_2[key]), false), __read(prop), false);
                        }
                        else if (Object == prop.constructor) {
                            nextEntity_2[key] = __assign(__assign({}, nextEntity_2[key]), prop);
                        }
                        else {
                            nextEntity_2[key] = prop;
                        }
                    });
                    newState[id] = nextEntity_2;
                }
            });
            return newState;
        },
    };
}
exports.mapReducers = mapReducers;
function createMap(_a) {
    var name = _a.name, extraReducers = _a.extraReducers, _b = _a.initialState, initialState = _b === void 0 ? {} : _b;
    var slice = (0, create_slice_1.default)({
        name: name,
        initialState: initialState,
        extraReducers: extraReducers,
        useImmer: false,
        reducers: mapReducers(initialState),
    });
    return slice;
}
exports.default = createMap;
//# sourceMappingURL=create-map.js.map