"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createReducerPlain = void 0;
var immer_1 = __importDefault(require("immer"));
function createReducerPlain(initialState, reducers) {
    var reducer = function (state, action) {
        if (state === void 0) { state = initialState; }
        var caseReducer = reducers[action.type];
        if (!caseReducer) {
            return state;
        }
        return caseReducer(state, action.payload);
    };
    return reducer;
}
exports.createReducerPlain = createReducerPlain;
function createReducer(initialState, reducers) {
    var reducer = function (state, action) {
        if (state === void 0) { state = initialState; }
        return (0, immer_1.default)(state, function (draft) {
            var caseReducer = reducers[action.type];
            if (!caseReducer) {
                return draft;
            }
            return caseReducer(draft, action.payload);
        });
    };
    return reducer;
}
exports.default = createReducer;
//# sourceMappingURL=create-reducer.js.map