import type { Action, ActionsObjWithSlice, ActionsAny, Reducer } from './types';
interface SliceOptions<SliceState = any, Ax = ActionsAny> {
    initialState: SliceState;
    reducers: ActionsObjWithSlice<SliceState, Ax>;
    name: string;
    extraReducers?: ActionsAny;
    useImmer?: boolean;
}
export default function createSlice<SliceState, Actions extends ActionsAny>({ name, initialState, reducers, extraReducers, useImmer, }: SliceOptions<SliceState, Actions>): {
    name: string;
    reducer: Reducer<SliceState, Action>;
    actions: {
        [key in keyof Actions]: Object extends Actions[key] ? (payload?: any) => Action : Actions[key] extends never ? () => Action : (payload: Actions[key]) => Action<Actions[key]>;
    };
    toString: () => string;
};
export {};
