"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var create_action_1 = __importDefault(require("./create-action"));
var create_reducer_1 = __importStar(require("./create-reducer"));
var actionTypeBuilder = function (slice) { return function (action) {
    return slice ? "".concat(slice, "/").concat(action) : action;
}; };
function createSlice(_a) {
    var name = _a.name, initialState = _a.initialState, reducers = _a.reducers, extraReducers = _a.extraReducers, _b = _a.useImmer, useImmer = _b === void 0 ? true : _b;
    if (!name) {
        throw new Error("createSlice name must not be blank");
    }
    var actionKeys = Object.keys(reducers);
    var createActionType = actionTypeBuilder(name);
    var reducerMap = actionKeys.reduce(function (map, action) {
        var scopedAction = createActionType(action);
        map[scopedAction] = reducers[action];
        return map;
    }, extraReducers || {});
    var reducer = useImmer
        ? (0, create_reducer_1.default)(initialState, reducerMap)
        : (0, create_reducer_1.createReducerPlain)(initialState, reducerMap);
    var actionMap = actionKeys.reduce(function (map, action) {
        var type = createActionType(action);
        map[action] = (0, create_action_1.default)(type);
        return map;
    }, {});
    return {
        actions: actionMap,
        reducer: reducer,
        name: name,
        toString: function () { return name; },
    };
}
exports.default = createSlice;
//# sourceMappingURL=create-slice.js.map